
; *****************************************************
; Dyamic Shadows Demo for use with BlitzBasic 3D for PC
; *****************************************************

; One more Realtime Shadow by norc
; optimized by Peter Scheutz
; THX to Rob for the FLEX Idea!
; finally realtime shadows on large sceneries!

; Note: maybe you will have to fiddle a bit 
; around when you edit Ambientlight aso.
; Don't ewxpect perfect Shadows in all
; Situations - some bugs still might be fixed,
; you'll see what I mean. Hope this is useful anyway.

width=640
height=480
Graphics3D width,height,16,2
SetBuffer BackBuffer()

protago=CreatePivot() ; main 'Actor'-Pivot
i#=0:j#=0
Global surf=0

; create some Geometry for the Demo, plus camera lights etc
flotex=LoadTexture("mossyground.jpg")
flotex2=LoadTexture("stone1.jpg")
ScaleTexture flotex,25,25

hero=LoadMD2("tris.md2",protago)
herotex=LoadTexture("armour.pcx")
EntityTexture hero,herotex
RotateEntity hero,0,180,0
ScaleEntity hero,2,2,2
;AnimateMD2 hero,1,0.2,40,45 ; run
;AnimateMD2 grunt,1,0.2,0,37 ; look/wait

camera=CreateCamera(protago)
PositionEntity camera,0,100,200
PointEntity camera,protago
CameraFogMode camera,1
CameraFogRange camera,500,10000
CameraFogColor camera,200,220,255


light=CreateLight(2,protago)
PositionEntity light,200,500,0

;AmbientLight 100,100,100

mng=126
mng2=Int(mng/2)
halfwidth=width/2
halfheight=height/2
sp_s=0
sp_e=126
grabx=halfwidth-mng2
graby=halfheight-mng2
Const stpx=1
Const stpz=1

limat=CreateTexture(mng+1,mng+1,16 Or 256)
ScaleTexture limat,1.0,-1.1
PositionTexture limat,0,0.05

; HWMultiTex 0 ; try this when you cannot see any shadow

; create Shadow FLEX-Mesh
gridx=9
gridz=9
Dim map#(gridx,gridz)
mesh=Create_Map(gridx,gridz)
ScaleEntity mesh,3,3,3
PositionEntity mesh,EntityX(protago),EntityY(protago)+2,EntityZ(protago)
EntityTexture mesh,limat,0,0
EntityBlend mesh,2
EntityFX mesh,8

;Test Ground
Global earth=LoadTerrain("lmap_1024.jpg") ; use a 128*218 Heightmap image
ScaleEntity earth,60,500,60
PositionEntity earth,-1270,-100,-1270
EntityBlend earth,1
EntityTexture earth,flotex,0,0
EntityPickMode earth,2
ScaleTexture flotex2,4,4
EntityTexture earth,flotex2 ,0,1


; Some objects to show aligning shadow Mesh on multiple Objects
; In fact these are Discs - but hey - the Computer don't knows that.
ncubes=10
Dim cubes(ncubes)
For i=0 To ncubes
 cubes(i)=CreateSphere(6)
 x#=Rand(-500,500)
 z#=Rand(-500,500)
 y#=TerrainY(earth,x,0,z)-7
 PositionEntity cubes(i),x,y,z
 RotateEntity cubes(i),Rand(-10,10),Rand(360),Rand(-10,10)
 ScaleEntity cubes(i),50,15,50
 EntityPickMode cubes(i),2
 EntityTexture cubes(i),flotex2
Next



shadowColor=130

;this texture is used for the Actor when the shadow silhouette is rendered
shadowColor=130  ; HERE YOU CAN SET THE SHADOW DARKNESS !!!! (0 to 255)
shadetex=CreateTexture(64,64)
SetBuffer TextureBuffer(shadetex)
Color shadowColor,shadowColor,shadowColor
Rect 0,0,64,64,1
SetBuffer BackBuffer()

xplayer#=2700
zplayer#=700
AnimateMD2 hero,1,0.2,0,37 ; look/wait

HidePointer
; ________________________________________MAIN LOOP_____________________________________
While KeyDown(1)=0
    ; check user interaction
    ma#=ma# - (MouseXSpeed()/4)
    my#=my# + MouseYSpeed()
    If my#>480 Then my#=480
    If my#<0 Then my#=0
    If ma#>360 Then ma#=0
    If ma#<0 Then ma#=360
    k208=0:k200=0
    If KeyDown(200)=1 Then
     zplayer#=zplayer#-(Sin(ma#+90)*10)
     xplayer#=xplayer#-(Cos(ma#+90)*10)
     If walking=0
      AnimateMD2 hero,1,0.2,40,45 ; run fwd
     EndIf
     walking=1
     k200=1
    EndIf
    If KeyDown(208)=1 Then
     zplayer#=zplayer#+(Sin(ma#+90)*10)
     xplayer#=xplayer#+(Cos(ma#+90)*10)
     If walking=0
      AnimateMD2 hero,1,0.2,40,45 ; run bwd
     EndIf
     walking=1
     k208=1
    EndIf
    If k200=0 And k208=0 And walking=1
     AnimateMD2 hero,1,0.2,0,37 ; look/wait
     walking=0
    EndIf

    ; positioning actor
    ypic=LinePick(xplayer,1000,zplayer,0,-2000,0,1.0)
    PositionEntity protago,xplayer,PickedY()+50,zplayer ; this will allow your actor to walk on any pickable Mesh
    PositionEntity mesh,EntityX(protago),0,EntityZ(protago),1 ; ...align Shadow Mesh...
    RotateEntity protago,0,ma#,0
    RotateEntity mesh,0,0,0
    Gosub intouch
    ;-----------------------------------------------------------------
    ; Produce a Lightmap
    PositionEntity camera,xplayer,EntityY(protago)+200,zplayer-100,1 ; Play with this Y-Value 180
    RotateEntity camera,70,0,0,1
    CameraViewport camera,grabx,graby,mng,mng
    CameraZoom camera,2;1.2         ; and play with this Zoom-Value
    CameraClsColor camera ,255,255,255

    
    ; hide everything but the main actor
    For i=0 To ncubes
     HideEntity cubes(i)
     EntityFX cubes(i),1
    Next
    EntityTexture hero,shadetex  ; use grey dummy texture on actor as shadow-color
    EntityFX hero,1

    EntityAlpha mesh,0.0
    EntityAlpha earth,0.0
    CameraFogMode camera,0
   
    RenderWorld()  ; render the Shadow Contour (from the suns perspective)

    For i=0 To ncubes     ; unhide the scene, reset all texturesettings, camera aso.
     ShowEntity cubes(i)
     EntityFX cubes(i),0
    Next
    EntityTexture hero,herotex
    EntityFX hero,0

    EntityAlpha mesh,1.0
    EntityAlpha earth,1.0

    CameraZoom camera,1.0
    CameraFogMode camera,1
    ; move the Shadow Contour to the FLEX Texturebuffer
    CopyRect grabx,graby,127,127,0,0,BackBuffer(),TextureBuffer(limat)

    ;-----------------------------------------------------------------
    ; Render the Scene normally....
    CameraClsColor camera ,200,220,255

    CameraViewport camera,0,0,width,height
    camrot#=camrot#+1.0
    If camrot#>360 Then camrot#=camrot#-360
    camrot2#=camrot2#+3.0
    If camrot2#>360 Then camrot2#=camrot2#-360

    ypic=LinePick(    xplayer+(Cos(ma#+90)*200),1500,zplayer+(Sin(ma#+90)*200)       ,0,-3000,0,1.0   )
    PositionEntity camera,xplayer+(Cos(ma#+90)*200),PickedY()+150+my/3,zplayer+(Sin(ma#+90)*200),1
;    PositionEntity camera,Cos(camrot#)*200,50+MouseY()/3,Sin(camrot#)*200 ; camera alternative
;    PositionEntity camera,xplayer+(Cos(ma#+90)*200),500,zplayer+(Sin(ma#+90)*200),1 ; another camera alternative
    PointEntity camera,protago

    UpdateWorld()
    MoveMouse width/2,height/2
    RenderWorld()

    tt=MilliSecs()
    fps#=1000/(tt-ttold)
    ttold=tt
    Text 10,10,"FPS: "+Int(fps#)
    Text 10,20,"Use Cursor + Mouse"
    Text 10,30,xplayer+" "+zplayer

    Flip ;False
Wend
ShowPointer
End


;MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM

Function Create_Map(tilex,tilez)
; make a quad patch with shared vertices...
 mesh=CreateMesh()
 surf=CreateSurface(mesh,0)
 cnt=0
 For j#=0 To tilez
  For i#=0 To tilex
   AddVertex surf,(i*10)-50,0,(j*10)-50,i/10.0,j/10.0
   cnt=cnt+1
  Next
 Next
 cnt=0
 For j#=0 To tilez-1
  For i#=0 To tilex-1
   AddTriangle surf,i+(j*10),i+((j+1)*10)+1,i+(j*10)+1
   AddTriangle surf,i+(j*10),i+((j+1)*10),i+((j+1)*10)+1
  Next
 Next
 UpdateNormals mesh
 Return mesh
End Function

.intouch
; align quad patch to ground (any pickable geometry)
 cnt=0
 For j#=0 To 9
  For i#=0 To 9
   xv#=VertexX(surf,cnt)
   zv#=VertexZ(surf,cnt)
   under=LinePick(xplayer+(i*30)-150,500,zplayer+(j*30)-150,0,-1000,0,1)
   If under<>0
    y#=PickedY#()/3+4 ;(remember the mesh was scaled *3!)
   Else
    y#=-100
   EndIf
   VertexCoords surf,cnt,xv,y,zv
   cnt=cnt+1
  Next
 Next
 UpdateNormals mesh
Return